;*******************************************************************
;;commandes pour la liaison entre POWER-CLIC et une autre application
;;functions designed to link PowerClic with an other application
;;*******************************************************************

;;
;; n_ent := nom de l'entit(<ename>) Powerclique, globale dans powerclic
;; n_ent := entity name (<ename>) PowerClicked, global in powerclic

;; this function appears in thematic.ini
(defun sample_link ( / )
  
  ;;make an entget on n_ent
  (setq eg (entget n_ent))
  ;;note that you can pass information only threw global variable
  (if (setq global-col (assoc 62 eg))
   ;;returns command name
   "(c:sample_execution)"
   "(c:sample_nothing )"
  )
  
)

;; this is running after
(defun c:sample_execution ( / )
  (alert "\nThis entity as a color defined !")
  ;;init to this color
  (setvar "cecolor" (itoa (cdr global-col)))
)

;; or this ..
(defun c:sample_nothing ( / )
  (alert "\nThis entity as NO color defined !")
)


;*******************************************************************
;;commandes plug-in de POWER-CLIC e
;;functions designed to be a plug-in under PowerClic 
;;*******************************************************************
; HACHURER
;;*******************************************************************
;;/plugg/ hachure les element ferms - hatch closed element/none
;; enregistre le plug-in pour les polylignes, les lwpolylignes et les regions
;; register this plug-in for polylines and region entities
(pw_pluggin_register '("hatch_it" ("POLYLINE" "LWPOLYLINE" "RECTANG" "POLYGONE" "REGION" "ELLIPSE" "CIRCLE" ) ("hachure les elements ferms" " - " "hatch closed elements" )))

;;definition de la commande - function definition
(defun hatch_it ( / sel lobj l)
 (setq sel (ssget "_p" ))
 (setq lobj (pw_listsel sel))
 (foreach l lobj
   (setq lent (entget l))
   (setq tpent (cdr (assoc 0 lent)))
   (if (or (= "POLYLINE" tp)(= "LWPOLYLINE" tp))
     (if (= 1 (rem (cdr (assoc 70 lent)) 2)) ;;ferme
       (command "_bhatch" "_s" l ""  "")
     )
     (command "_bhatch" "_s" l ""  "")        
   ) 
 )
)
;;*******************************************************************
;;/plugg/ hachure les element ferms  partir d'une taille - hatch closed element according to their dimension/none
;;hachure  partir d'une certaine taille
;; enregistre le plug-in pour les polylignes, les lwpolylignes 
(pw_pluggin_register '("hatch_by_length" ("POLYLINE" "LWPOLYLINE" "RECTANG" "POLYGONE" ) ("hachure les element ferms  partir d'une taille" "-" "hatch closed element according to their dimension" )))

;;definition de la commande - function definition
(defun hatch_by_length ( / sel lobj l tohach ss )
 (pw_getrealmem (pw_getxt 'PW101 "perimetre minimum pour hachurer") "perim-mini")
 (setq sel (ssget "_p" ))
 (setq lobj (pw_listsel sel))
 (foreach l lobj
   (setq lent (entget l))
   (setq tpent (cdr (assoc 0 lent)))
   (if (or (= "POLYLINE" tp)(= "LWPOLYLINE" tp))
     (if (= 1 (rem (cdr (assoc 70 lent)) 2)) ;;ferme
       (setq tohach l)
       (setq tohach nil)       
     )
     (setq tohach l)       
   )
   (if tohach
    (progn
     (setq ss (pw_selist (list tohach)))
     (if (> (pw_lin_jslong ss) perim-mini)
       nil
       (setq tohach nil)
      )
     )
   )
   (if tohach
     (command "_bhatch" "_s" l ""  "")
   ) 
 )
)
;;*******************************************************************
;;/plugg/ selection par les elements ferms - select with closed elements/none
;; enregistre le plug-in pour les polylignes, les lwpolylignes et les regions
;; register this plug-in for polylines and region entities
(pw_pluggin_register '("select_inside" ("POLYLINE" "LWPOLYLINE"  "RECTANG" "POLYGONE" )("selection par les elements ferms" "-" "select with closed elements" )))

;;definition de la commande - function definition
(defun select_inside ( / sel lobj l)
 (setq sel (ssget "_p" ))
 (setq lobj (pw_listsel sel))
 (command "_select")
 (foreach l lobj
    (setq ls (pw_lsomm l))
    (command "_WP")
    (foreach p ls
     (command (pw_scg2scu p))
    )
    (command "")
 )
 (command "")
 (setq sel (ssget "_p"))
 (sssetfirst sel sel)
)



;*******************************************************************************
;;/plugg/ detourer un texte - TEXTWIPOUT/none
;; detoure les textes - text wipout
;; This show how to take care of local
(cond
  ((= "english" pw-foreign)
   (if acet-geom-textbox
    (pw_pluggin_register '("textwipout" ("TEXT" "MTEXT" "LEADER" )("text wipout using solid and rectang")))
    (pw_pluggin_register '("textwipout" ("TEXT"  )))
   )
   (defun textwipout ()
     (text_masq)
   )
  )
  (t
   (if acet-geom-textbox
    (pw_pluggin_register '("detourer" ("TEXT" "MTEXT" "LEADER" )("detoure les textes avec un cadre et un solide")))
    (pw_pluggin_register '("detourer" ("TEXT" )))
   )
   (defun detourer ()
     (text_masq)
   )
  )
 )
;;definition de la commande - function definition
(defun text_masq ( / sel l lctour so cframe eg l2)
;; store used value in vx, so vx keep global
 (setq cframe (pw_ch_choix "Create frame ?" "Yes No" "Yes"))

 ;;selection obtenue avant (par powerclic)
 (setq sel (pw_listsel (ssget "_p")))
 (foreach l sel
   (if acet-geom-textbox
     (progn
       (setq eg (entget l))
       (if (not (member (cdr (assoc 0 eg)) '("TEXT" "MTEXT")));;une entit complexe
	 (setq eg (entget (setq l2 (cdr (assoc 340 eg))))) ;;trouve le texte
	 (setq l2 nil)
	)
       (setq lctour (acet-geom-textbox eg 0.35))
     )
     (setq lctour (pw_cadrtxt l))
   )
   (pw_setvar1 "cecolor" "255")
   ;;draw masq
   (command "_solid" (nth 0 lctour)  (nth 1 lctour) (nth 3 lctour) (nth 2 lctour) "")
   (setq so (entlast))
   (pw_setvar2 "cecolor")
   ;;draw frame
   (if (= "YES" cframe)
    (command "_pline" (nth 0 lctour)  (nth 1 lctour)  (nth 2 lctour) (nth 3 lctour) "_close")
   )
   ;;now draworder
   (if (wcmatch pw-vers "15*")
    (progn
      (command "_draworder" l "" "_above" so) ;under/above
      (if l2
       (command "_draworder" l2 "" "_above" so) ;under/above
      )
    )
    (progn
     (command "_copy" l "" "0,0" "@")
     (entdel l)
    ) 
   )
 )

)

;*******************************************************************************
;/plugg/exporter le texte selectionn dans un fichier - export selected text into a file/none
(pw_pluggin_register '("txtreport" ("TEXT" "MTEXT")("exporter le texte selectionn dans un fichier" "-" "export selected text into a file" )))

(defun txtreport (/ f txt sel fscr )
 (if (setq fscr (getfiled "Report file name :" "" "txt" 1))
  (progn
   (setq f (open fscr "w"))
    ;;selection obtenue avant (par powerclic)
   (setq sel (pw_listsel (ssget "_p")))
   (foreach l sel
     (setq txt (cdr (assoc 1 (entget l))))
     (write-line txt f)
   )
   (close f) 
  )
 )
)

; ****************************************************************************
;;/plugg/ passe par dessus les entits selectionnes (Draworder en dur)/none
;
(pw_pluggin_register '("move2thetop" ( "*" )("passe par dessus les entits selectionnes (Draworder en dur)" "" "copy to the top" )))

(defun move2thetop ()
  (pw_setvar1 "cmdecho" 0)
  (command "_copy" "_p" "" "0,0" "@")
  (command "_erase" "_p" "")
  (command "_redraw")
  (pw_setvar2 "cmdecho" )
)

; ****************************************************************************
;;/plugg/ copie les entits selectionnes dans un autre calque /none
;
(pw_pluggin_register '("copy2otherlayer" ( "*" )("copie les entits selectionnes dans un autre calque" "-" "Copy selected entities in an other layer" "Layer must be already defined")))

(defun copy2otherlayer ( / len plf sel )
  (pw_setvar1 "cmdecho" 0)
  (setq len (entlast))
  (command "_copy" "_p" "" "0,0" "@")
  (setq sel (pw_selafter len))
  (setq plf (cdr (assoc 8 (entget (entlast)))))
  (setq plf (pw_ch_layer  plf))
  (command "_chprop" (eval sel) "" "_layer" plf "")
  (command "_redraw")
  (pw_setvar2 "cmdecho" )
)

